(function() {
  var ConsoleAuth,
    __slice = [].slice,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; };

  Batman.ViewStore.prefix = '/auth/views/';

  Batman.Filters.curry = function() {
    var f, params;
    f = arguments[0], params = 2 <= arguments.length ? __slice.call(arguments, 1) : [];
    return function() {
      var args, event, renderContext;
      args = Array.prototype.slice.call(arguments);
      renderContext = args.pop();
      event = args.pop();
      args.push.apply(args, params);
      args.push(event);
      args.push(renderContext);
      return f.apply(this, args);
    };
  };

  ConsoleAuth = (function(_super) {

    __extends(ConsoleAuth, _super);

    function ConsoleAuth() {
      return ConsoleAuth.__super__.constructor.apply(this, arguments);
    }

    ConsoleAuth.global(true);

    ConsoleAuth.root('user#admin');

    ConsoleAuth.route('admin', 'user#admin');

    ConsoleAuth.togglePopover = function(target, id) {
      var $popup, $target, left, top;
      $popup = $("#" + id);
      $target = $(target);
      if ($popup.is(':visible')) {
        return;
      }
      $popup.attr({
        tabindex: -1
      });
      $popup.blur(function() {
        return $popup.fadeOut(100, function() {
          return $popup.attr({
            tabindex: null
          });
        });
      });
      if ($popup.hasClass('left') || $popup.hasClass('right')) {
        top = $target.position().top + ($target.outerHeight() / 2) - ($popup.outerHeight() / 2);
        left = $target.position().left + ($popup.hasClass('left') ? -($popup.outerWidth() + 4) : $target.outerWidth() + 4);
      } else if ($popup.hasClass('above') || $popup.hasClass('below')) {
        left = $target.position().left + ($target.outerWidth() / 2) - ($popup.outerWidth() / 2);
        top = $target.position().top + ($popup.hasClass('above') ? -$popup.outerHeight() : $target.outerHeight());
      }
      if (left < 0) {
        left = void 0;
      }
      $popup.animate({
        top: top,
        left: left
      }, 0);
      if (left == null) {
        $popup.find('.arrow').css({
          left: $target.offset().left - $popup.offset().left + $target.width() / 2
        });
      }
      $popup.fadeIn(100);
      return $popup.focus();
    };

    ConsoleAuth.goBack = function() {
      return window.history.back();
    };

    return ConsoleAuth;

  })(Batman.App);

  ConsoleAuth.UserController = (function(_super) {

    __extends(UserController, _super);

    function UserController() {
      this.create = __bind(this.create, this);
      return UserController.__super__.constructor.apply(this, arguments);
    }

    UserController.prototype.new_user = null;

    UserController.prototype.sortBy = 'username';

    UserController.prototype.admin = function() {
      var _this = this;
      this.set('new_user', new User);
      this.set('isNew', 'old');
      this.set('creationError', null);
      this.get('new_user').set('role', 'read-only');
      return $('html').click(function() {
        $('.update').hide();
        $('#user_list tr').removeClass('selected');
        return $('.table tbody tr .inner.selected').removeClass('selected');
      });
    };

    UserController.prototype.create = function(target) {
      var _this = this;
      $('#submit_user').addClass('disabled').text('Adding...');
      return this.get('new_user').save(function(err, result) {
        _this.set('creationError', null);
        if (err) {
          if (err.responseText !== void 0) {
            _this.set('creationError', err.responseText);
          } else if (err._storage !== void 0) {
            _this.set('creationError', err._storage[0].message);
          }
          $('#submit_user').removeClass('disabled').text('Add User');
          return $('#email').css('border-color', '#DA4F49');
        } else {
          _this.set('new_user', new User);
          _this.get('new_user').set('role', 'read-only');
          _this.set('isNew', result.id);
          setTimeout((function() {
            return $('.table.inner.selected').removeClass('selected');
          }), 4000);
          $('#email').css('border-color', '#ccc');
          return $('#submit_user').removeClass('disabled').text('Add User');
        }
      });
    };

    UserController.prototype.toggleRole = function(target) {
      return this.get('new_user').set('role', $(target).val());
    };

    return UserController;

  })(Batman.Controller);

  ConsoleAuth.AccountType = (function(_super) {

    __extends(AccountType, _super);

    function AccountType() {
      return AccountType.__super__.constructor.apply(this, arguments);
    }

    AccountType.global(true);

    AccountType.persist(Batman.RestStorage);

    AccountType.url = '/auth/account_types';

    AccountType.storageKey = 'account_types';

    AccountType.prototype.$primaryKey = 'id';

    AccountType.encode('id', 'type', 'role');

    return AccountType;

  })(Batman.Model);

  ConsoleAuth.User = (function(_super) {

    __extends(User, _super);

    function User() {
      return User.__super__.constructor.apply(this, arguments);
    }

    User.global(true);

    User.persist(Batman.RestStorage);

    User.url = '/auth/users';

    User.storageKey = 'users';

    User.primaryKey = 'id';

    User.encode('id', 'username', 'origin', 'role', 'status', 'email_sent', 'activation_link', 'current_admin');

    User.validate('username', {
      presence: true
    });

    User.validate('role', {
      presence: true
    });

    User.on('loading', function() {
      var _this = this;
      return setTimeout((function() {
        return _this.set('batmanState', 'loading');
      }), 0);
    });

    User.on('loaded', function() {
      var _this = this;
      return setTimeout((function() {
        return _this.set('batmanState', 'loaded');
      }), 0);
    });

    User.accessor('userEmail', function() {
      return "" + (this.get('email_sent'));
    });

    User.accessor('hasEmail', function() {
      return this.get('userEmail').length > 2;
    });

    User.accessor('userKey', function() {
      return "" + (this.get('activation_link'));
    });

    User.accessor('hasKey', function() {
      return this.get('userKey').length > 2;
    });

    User.prototype.saveChanges = function(target) {
      var new_email;
      new_email = $(target).parent().parent().parent().find('.info_email').val();
      $(target).text('Saving...').addClass('disabled');
      this.set('username', new_email);
      return this.save(function(err, result) {
        $(target).parents('.update').delay(500).fadeOut();
        $(target).text('Save changes').removeClass('disabled');
        return $(target).parents('tr.selected').toggleClass();
      });
    };

    User.prototype.removeUser = function(target) {
      var user_email;
      this.set('showDelete', 'show');
      user_email = this.get('username');
      return $(target).parent().find('dfn').html("Are you sure you want to permanently remove " + user_email + "?");
    };

    User.prototype.refreshPassword = function(target) {
      var user_email;
      this.set('showReset', true);
      user_email = this.get('username');
      return $(target).parent().find('dfn').html("Are you sure you want to reset " + user_email + "'s password?");
    };

    User.prototype.confirmDelete = function(target) {
      var user, user_email;
      user = this;
      user_email = user.get('username');
      return $(target).parents('tr.selected .table_wrapper').animate({
        height: 'toggle'
      }, {
        duration: 1000,
        complete: user.destroy
      });
    };

    User.prototype.revertDelete = function(target) {
      this.set('showDelete', '');
      return $(target).parent().parent().find('dfn').html("Deleting a user's account is permanent. Please be certain.");
    };

    User.prototype.revertReset = function(target) {
      this.set('showReset', false);
      return $(target).parent().parent().find('dfn').html("Emails user to reset password and reactivate account. User status will be set to pending.");
    };

    User.prototype.changePassword = function(target) {
      var user, user_id,
        _this = this;
      user = this;
      user_id = this.get('id');
      return $.ajax('/auth/unset_password', {
        type: 'POST',
        data: {
          user_id: user_id
        },
        success: function(data) {
          user.set('status', data.status);
          user.set('email_sent', data.email_sent);
          return user.set('activation_link', data.activation_link);
        }
      });
    };

    User.prototype.toggleStatus = function(target) {
      return this.set('status', $(target).val());
    };

    User.prototype.toggleRole = function(target) {
      return this.set('role', $(target).val());
    };

    User.prototype.showInfo = function(target, event) {
      var element_pos, max_height, selected_parent, selected_update, update_pos, user_email;
      if (event.stopPropagation) {
        event.stopPropagation();
      } else {
        window.event.cancelBubble = true;
      }
      max_height = $('.admin .content').height();
      element_pos = $(target).offset().top;
      selected_update = $(target).next('div');
      update_pos = 43 + $(selected_update).height();
      selected_parent = $(target).parent().parent().parent();
      $(selected_update).removeClass('bottom');
      $(selected_update).removeClass('top');
      if (element_pos > 460 && max_height - 150) {
        $(selected_update).addClass('top');
        $(selected_update).css('top', "-" + update_pos + "px");
      } else {
        $(selected_update).addClass('bottom');
        $(selected_update).css('top', '55px');
      }
      $('.update').not(selected_update).hide();
      $('tr.selected').not(selected_parent).removeClass('selected');
      $(target).parent().parent().siblings().removeClass('selected');
      $(target).parent().parent().parent().siblings().find('.inner').removeClass('selected');
      $(target).next('div').fadeToggle();
      $(target).parent().parent().parent().toggleClass('selected');
      user_email = $(target).find('.user_email').text();
      return $(target).parent().parent().find('.info_email').val(user_email);
    };

    User.prototype.updateInfo = function(target, event) {
      if (event.stopPropagation) {
        return event.stopPropagation();
      } else {
        return window.event.cancelBubble = true;
      }
    };

    User.prototype.relocate = function(target, event) {
      return window.open($(target).attr('href'));
    };

    return User;

  })(Batman.Model);

}).call(this);
