require 'yaml'
require 'digest/md5'

class Emcee
  class CacheBase
    attr_reader :key

    def initialize(key, options = {})
      @key = key
      @options = options
    end

    def data(&block)
      return load if cached?
      save(yield)
    end

    def digest
      @digest ||= Digest::MD5.new.hexdigest(YAML.dump(key))
    end

    def log(message)
      Emcee.logger.info(message)
    end
  end
end
